<template>

  <div>
    <v-card :class="mainClass" :id="application.id">
      <v-card-title primary-title class="text-xs-left">
        <v-flex xs12>
            <template>
                <slot name="header">
                    <div class="subheading position">
                        <span>
                            <router-link v-if="linkDetails" :to="{ path: '/secure/view', query: {id: application.id} }" class="unstyled-link">
                                {{application.title}}  
                            </router-link>
                            <span v-if="!linkDetails">{{application.title}}</span> 
                        </span>
                        <a v-if="application.listingUrl" class="unstyled-link" :href="application.listingUrl" target="_blank">
                            <v-icon color="primary" class="body-2" style="font-size: 12px !important; vertical-align: middle">launch</v-icon>
                        </a>
                    </div>
                    
                    <div class="caption" :style="'color: #777; ' + (!application.location ? 'font-style: italic;' : '')">
                        <div v-if="collapsed">{{application.company.name}}, {{application.location || $i18n.t("application.locationNotSet")}}</div>
                        <div v-else>{{application.location || $i18n.t("application.locationNotSet")}}</div>
                    </div>
                </slot>
            </template>
        </v-flex>
      </v-card-title>
      <v-divider light></v-divider>
      
      <v-card-text class="text-xs-left mb-0 pb-0" v-if="!collapsed">
           <v-flex xs12 class="caption mb-2">
                <img v-if="application.company && application.company.logo" :src="application.company.logo" 
                     style="width:16px; vertical-align: top; border-radius: 8px ">
                <a v-if="application.company.domain" style="color:inherit; text-decoration: none;" :href="'//' + application.company.domain" target="_blank">
                    <span class="pl-2" style="font-weight: 600">{{application.company.name}}</span>
                </a>
                <span v-if="!application.company.domain" class="pl-2" style="font-weight: 600">{{application.company.name}}</span>
           </v-flex>
           
           <template>
               <slot name="body">
                    <v-flex xs12 class="mb-1 update-time">
                         {{$i18n.t("common.created.fm")}} {{formatDate(application.applicationDate, $i18n.t("common.dateFormat"))}}
                    </v-flex>
                    
                    <template>
                        <slot name="innerBody">
                           <v-flex xs12 v-if="application.description"> 
                               <div :class="descriptionClass" 
                                     v-html="application.description" 
                                     style="white-space: pre-line;"></div>
                               <div v-if="application.description.length > 99" :class="'expand-collapse ' + (expand ? '' : 'collapsed')" @click="expand = !expand">
                                  <v-icon color="primary">{{expand ? 'arrow_drop_up' : 'arrow_drop_down'}}</v-icon>
                               </div>
                           </v-flex>
                           <v-flex xs12 v-else :class="'description ' + noDescriptionMarginTop">
                                <span style="font-style: italic; color: #999">{{ $i18n.t("application.noDescription") }}</span>
                           </v-flex>
                        </slot>
                    </template>
                    
                    <v-flex xs12 class="update-time">
                        <v-layout row>
                            <v-flex xs3 class="mt-4 pr-2">
                               <span class="ellipsis" v-if="hasNotes">{{noteCount}}</span>
                            </v-flex>
                            <v-flex xs9 class="text-xs-right mt-4">
                               {{$i18n.t("common.updated.fm")}} {{formatDate(application.lastUpdate)}}
                            </v-flex>
                        
                        </v-layout>
                    </v-flex>
               </slot>
           </template>
           
      </v-card-text>  
        
      <v-divider light v-if="!collapsed"></v-divider>
      
      <v-card-actions right>
        
        <v-btn  v-if="isActionnable('collapse')" flat small icon @click="collapsed = !collapsed" >
            <v-icon small v-if="collapsed">expand_more</v-icon>
            <v-icon small v-else>expand_less</v-icon>
        </v-btn>
        
        <slot name="leftActions"></slot>
        
        <v-btn v-if="isActionnable('archive')" :disabled="!this.application.id" flat small icon @click="$emit('archive')">
            <v-icon small>archive</v-icon>
        </v-btn>

        <v-spacer/>
        <v-tooltip top style="font-size: 11px !important;">
            <span slot="activator" class="mr-2 interview-badge" v-if="hasInterviews">{{application.interviews.length}}</span>
            <span v-if="hasInterviews">{{interviewCount}}</span>
        </v-tooltip>
        
        <v-btn v-if="isActionnable('edit')" :disabled="!this.application.id" flat small icon>
           <v-icon small  @click="applicationDialog=true">edit</v-icon>
       </v-btn>
        
        <v-btn v-if="isActionnable('unarchive')" :disabled="!this.application.id" flat small icon @click="$emit('unarchive')">
          <v-icon small>unarchive</v-icon>
        </v-btn>
            
        <v-btn flat v-if="isActionnable('delete')" :disabled="!this.application.id" small icon @click="confirmDeleteDialog=true">
           <v-icon small>delete</v-icon>
       </v-btn>
            
      </v-card-actions>
    </v-card>
  
    <v-dialog v-model="confirmDeleteDialog" max-width="320">
      <v-card>
        <v-card-title class="headline">{{$i18n.t("application.delete.title")}}</v-card-title>
    
        <v-card-text>
          {{$i18n.t("application.delete.text")}}
        </v-card-text>
    
        <v-card-actions>
          <v-btn flat="flat" @click="confirmDeleteDialog = false">
            {{$i18n.t("application.delete.no")}}
          </v-btn>
          <v-spacer></v-spacer>
          <v-btn color="red darken-1" flat="flat" @click="$emit('remove'); confirmDeleteDialog = false">
            {{$i18n.t("application.delete.yes")}}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    
    <v-dialog v-if="editable" v-model="applicationDialog" persistent fullscreen hide-overlay>
            <ApplicationWizard :title="$i18n.t('application.form.editApplication')"
                    :model="applicationDialog" mode="edit" @save="applicationDialog = false"
                    @success="itemSaved" @error="$emit('error')"
                    v-model="application" @cancel="cancelEdit()" @close="closeWizard()"/>
    </v-dialog>
    
  </div>
  
</template>

<script>
import moment from 'moment'
import ApplicationWizard from '../forms/ApplicationWizard'
export default {
  name: 'ApplicationCard',
  components: {
    ApplicationWizard
  },
  props: {
    noDescriptionMarginTop: {
      tpye: String,
      default: 'mt-3'
    },
    showInterviewBadge: null,
    initialState: null,
    draggable: {
        type: Boolean,
        default: true
    },
    item: Object, 
    showActions: Array,
    linkDetails: {
        type: Boolean,
        default: true
    },
    editable: {
        type: Boolean,
        default: true
    }, 
    hideActions: {
        type: Array,
        default: () => ['unarchive']
    }
  },
  data() {
    return {
      collapsed: this.initialState,
      confirmDeleteDialog: false,
      applicationDialog: false,
      expand: false,
      application: Object.assign({company: {}, contact: {}}, this.item)
    }
  },
  methods: {
    itemSaved(item) {
        this.application = item
        this.$emit('success', this.application)
    },
    cancelEdit() {
        this.application = this.item
        this.closeWizard() 
    },
    closeWizard() {
        this.applicationDialog = false    
    },
    formatDate(d, format) {
        return !format ? moment(d).fromNow() : moment(d).format(format)
    },
    isActionnable(key) {
        if ( this.showActions ) {
            return this.showActions.indexOf(key) >= 0;
        }
        else {
            if ( this.hideActions.indexOf('all') >= 0 ) return false;
            return this.hideActions.indexOf(key) < 0
        }
    }
  },
  computed: {
    mainClass() {
        return (this.$vuetify.breakpoint.smAndUp ? 'elevation-5 ' : '') + (this.draggable ? 'draggable' : 'non-draggable')
    },
    hasInterviews() {
        return this.application.interviews && this.application.interviews.length > 0;
    },
    noteCount() {
        return this.$i18n.tc("application.note", this.application.notes.length)
    },
    hasNotes() {
        return this.application.notes && this.application.notes.length > 0
    },
    interviewCount() {
        return this.$i18n.tc("application.interview", this.application.interviews.length)
    },
    descriptionClass() {
        return 'mt-3 description ' + (this.application.description.length > 99 ? ' clamp' : '') + (this.expand ? ' expand' : ' collapsed')
    }
  }
};
</script>

<style>
.position {
  height: 24px;
  overflow: hidden
}
.draggable {
  cursor: grab !important;
}
.non-draggable  {
  cursor: default !important;
}
.update-time {
  font-size: 70% !important;
  color: #777;
}
.interview-badge {
  cursor: default !important; 
  border-radius: 10px; 
  padding: 1px 10px; 
  background-color: green; 
  color: white; 
  font-weight: 600; 
  font-size: 80%;
}
.description {
  position: relative;
  height: 4.5em; 
  overflow: hidden;
}
.clamp.expand {
  height: auto;
  transition: height 400ms linear;
}
.expand-collapse {
  position: relative;
  height: 24px;
  width: 100%;
  text-align: center;
  cursor: pointer;
}
.expand-collapse.collapsed {
  margin-top: -24px;
  padding-top: 16px;
}
.clamp.collapsed::after {
  content: "";
  text-align: right;
  position: absolute;
  bottom: 0;
  right: 0;
  width: 100%;
  height: 3.2em;
  background: linear-gradient(to top, rgba(255, 255, 255, .75) 50%, rgba(255, 255, 255, 0));
}
</style>
